﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WebSocketSharp.Server;

namespace WebSocket_WPFServer_CSHTML5Client
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        public static WebSocketServer _webSocketServer;
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            _webSocketServer = new WebSocketServer(12345);
            _webSocketServer.AddWebSocketService<WebSocketService_ServerTime>("/WebSocketService_ServerTime");
            _webSocketServer.Start();

            textBox_Logs.Text = "WebSocket WebSocketService_ServerTime started on port 12345";
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            if (_webSocketServer != null)
            {
                _webSocketServer.Stop();
                textBox_Logs.Text = "WebSocket WebSocketService_ServerTime stopped.";
            }
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            var hosts = _webSocketServer.WebSocketServices.Hosts;
            var sessions = hosts.ElementAt(0).Sessions;
            sessions.Broadcast("hello everybody from Server ! " + DateTime.Now.ToString() );

            textBox_Logs.Text = "WebSocket WebSocketService_ServerTime Server broadcasted (mean: sent to all) message.";

            // note: to send NOT All clients, but only selected: 
            // use SendTo () with unique SessionID: you will get it in WebSocketService_ServerTime (store it when a client connected): see OnOpen()
            //sessions.SendTo("some message to only a certain client", string SessionID);
        }
    }
}
